VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "   "
   ClientHeight    =   5625
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5430
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5625
   ScaleWidth      =   5430
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer timRefresh 
      Interval        =   100
      Left            =   2160
      Top             =   2520
   End
   Begin VB.Frame Frame1 
      Caption         =   " "
      Height          =   1215
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5175
      Begin VB.CommandButton cmdAddVar 
         Caption         =   "&"
         Height          =   255
         Left            =   3600
         TabIndex        =   5
         Top             =   360
         Width           =   1455
      End
      Begin VB.TextBox txtValue 
         Height          =   285
         Left            =   1680
         TabIndex        =   4
         Top             =   720
         Width           =   1815
      End
      Begin VB.TextBox txtName 
         Height          =   285
         Left            =   1680
         TabIndex        =   2
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label Label2 
         Caption         =   ":"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   720
         Width           =   1575
      End
      Begin VB.Label Label1 
         Caption         =   " :"
         Height          =   255
         Left            =   120
         TabIndex        =   1
         Top             =   360
         Width           =   1695
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   " "
      Height          =   1455
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   5175
      Begin VB.CommandButton cmdRemove 
         Caption         =   "&"
         Height          =   255
         Left            =   3600
         TabIndex        =   15
         Top             =   360
         Width           =   1455
      End
      Begin VB.TextBox txtVarValue 
         Appearance      =   0  'Flat
         Height          =   405
         Left            =   240
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   8
         Top             =   840
         Width           =   4695
      End
      Begin VB.ComboBox cmbVars 
         Height          =   315
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   7
         Top             =   360
         Width           =   3255
      End
   End
   Begin VB.Frame Frame3 
      Caption         =   " "
      Height          =   1095
      Left            =   120
      TabIndex        =   9
      Top             =   2760
      Width           =   5175
      Begin VB.TextBox txtCommandLine 
         Height          =   735
         Left            =   120
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   10
         Top             =   240
         Width           =   4935
      End
   End
   Begin VB.Frame Frame4 
      Caption         =   "    "
      Height          =   1695
      Left            =   120
      TabIndex        =   11
      Top             =   3840
      Width           =   5175
      Begin VB.CommandButton cmdEvaluate 
         Caption         =   "..."
         Height          =   375
         Left            =   240
         TabIndex        =   14
         Top             =   1200
         Width           =   4695
      End
      Begin VB.TextBox txtNewCommandLine 
         Height          =   615
         Left            =   120
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   12
         Top             =   480
         Width           =   4935
      End
      Begin VB.CheckBox chkOverwrite 
         Caption         =   " "
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   240
         Value           =   1  'Checked
         Width           =   4815
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim MyVars As New Variables

Private Sub cmbVars_Click()
    txtVarValue.Text = MyVars.var(cmbVars.Text)
End Sub

Private Sub cmdAddVar_Click()
    On Error GoTo erhandle
    Dim strName As String, strValue As String
    strName = txtName.Text
    If strName = "" Then
        MsgBox "   !", vbExclamation
        Exit Sub
    End If
    
    strValue = txtValue.Text
    
    MyVars.Add strName, strValue
    RefreshList
    Exit Sub
    
erhandle:

    Select Case Err.Number
        Case 457
            If MsgBox("     ." & vbCrLf & _
            "   ?", vbExclamation + vbYesNo) = vbYes Then
                MyVars.var(strName) = strValue
            Else
                Resume Next
            End If
    End Select
End Sub

Private Sub RefreshList()
    Dim var As Variable
    
    cmbVars.Clear
    For Each var In MyVars
        cmbVars.AddItem var.VarName
    Next var
    
    txtCommandLine.Text = MyVars.CommandLine
End Sub

Private Sub cmdEvaluate_Click()
    If chkOverwrite.Value = vbChecked Then
        MyVars.EvaluateString txtNewCommandLine.Text
    Else
        MyVars.EvaluateString txtNewCommandLine.Text, False
    End If
    RefreshList
End Sub

Private Sub cmdRemove_Click()
    On Error GoTo erhandle
    Dim strName As String
    strName = cmbVars.Text
    If strName = "" Then
        MsgBox "  !", vbExclamation
        Exit Sub
    End If
    
    MyVars.Remove strName
    RefreshList
    Exit Sub
    
erhandle:
    Debug.Print "error in Remove (" & Err.Number & ")"
    Select Case Err.Number
        Case 5
            MsgBox "    " & strName & "." & vbCrLf & _
            "      .", vbExclamation
    End Select
    Resume Next
End Sub

Private Sub txtName_GotFocus()
    With txtName
        .SelStart = 0
        .SelLength = Len(txtName.Text)
    End With
End Sub

Private Sub txtValue_GotFocus()
    With txtValue
        .SelStart = 0
        .SelLength = Len(txtValue.Text)
    End With
End Sub
