VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Variables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Variable"
Attribute VB_Ext_KEY = "Member0" ,"Variable"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mCol As Collection
Private blnCalledFromReset As Boolean
'  
Public Delimeter As String

Public Function Add(VarName As String, Value As Variant) As Variable
    Dim objNewMember As Variable
    Set objNewMember = New Variable
    objNewMember.VarName = VarName
    If IsObject(Value) Then
        Set objNewMember.Value = Value
    Else
        objNewMember.Value = Value
    End If
    mCol.Add objNewMember, VarName
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(VarName As Variant) As Variable
Attribute Item.VB_UserMemId = 0
    ',  ""     
    ' - Item    , -
    '      
    '.
  Set Item = mCol(VarName)
End Property

' 
Public Property Get Count() As Long
    Count = mCol.Count
End Property

' 
Public Sub Remove(VarName As Variant)
    mCol.Remove VarName
End Sub

' ,  Variables     
'For Each Variable In Variables....
Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    '   
    Set mCol = New Collection
    '  "" 
    Delimeter = Chr(156) & Chr(157) & Chr(156)
End Sub


Private Sub Class_Terminate()
    ' 
    Set mCol = Nothing
End Sub

'**************************************
' CommandLine
'    
'  
'**********************
Public Function CommandLine() As String
    Dim Str As String, var As Variable
    For Each var In mCol
        With var
            Str = Str & .VarName & "="
            Str = Str & .Value & Delimeter
        End With
    Next var
    CommandLine = Str
End Function

'***************************************
' Reset
'    
'  
' :
'   NewVars -    ,
'              - CommandLine
'            .    ,
'              ,   -
'              
Public Sub Reset(Optional ByVal NewVars As String = "-")
    Dim l As Long
    For l = mCol.Count To 1 Step -1
        mCol.Remove l
    Next
    If NewVars = "-" Then Exit Sub
    blnCalledFromReset = True
    EvaluateString NewVars
End Sub

'  
Public Property Get var(ByVal VarName As String)
    If IsObject(Item(VarName).Value) Then
        Set var = Item(VarName).Value
    Else
        var = Item(VarName).Value
    End If
End Property
',  
Public Property Let var(ByVal VarName As String, NewValue)
    If IsObject(NewValue) Then
        Set Item(VarName) = NewValue
    Else
        Item(VarName) = NewValue
    End If
End Property

'************************************
' EvaluateString
'     
'  
' :
'      ,  0
'     ,    
' :
'   NewCommandLine -  
'   WithReset -    ,
'                 ,     (True)
'                  (False)
'*********************
Public Function EvaluateString(ByVal NewCommandLine As String, Optional ByVal WithReset As Boolean = True) As Long
    On Error GoTo erhandle
    Dim strBuf As String
    Dim arrStrings() As String
    Dim arrVar() As String
    Dim l As Long
    strBuf = NewCommandLine
    
    '    
    '< >=<>
    arrStrings = Split(strBuf, Delimeter)
    
    If WithReset Then
    If Not blnCalledFromReset Then
        Reset
        blnCalledFromReset = False
    End If
    End If
    
    '      
    '  
    For l = 0 To UBound(arrStrings) - 1
        arrVar = Split(arrStrings(l), "=", 2)
        Add arrVar(0), arrVar(1)
    Next l
    EvaluateString = 0
    Exit Function
    
erhandle:
    Select Case Err.Number
        Case 457 '     
            Resume Next
        Case Else
            EvaluateString = Err.Number
            Exit Function
    End Select
End Function
